import { feature } from 'topojson';
import { csv, json } from 'd3';
export const loadAndProcessData = () => 
  Promise
    .all([
      csv('https://gist.githubusercontent.com/jesramyep1263/2733a2abd6763ea461349e9d14d9a8f2/raw/8b499dcfb025680c19b41b7dad7cae2dd9393263/population3.csv'),
      json('https://unpkg.com/visionscarto-world-atlas@0.0.4/world/50m.json')
    ])

    .then(([unData, topoJSONdata]) => {
     
      const rowById = unData.reduce((accumulator, d) => {
        accumulator[d['Country code']] = d;
        return accumulator;
      }, {});


      const countries = feature(topoJSONdata, topoJSONdata.objects.countries);
//console.log(countries.features.filter(d=>d.id=='239'));
      //d=>d.properties['2020']
      countries.features.forEach(d => {
        Object.assign(d.properties, rowById[+d.id])
              
      });
     const y=2020;
			const featuresWithPopulation=countries.features
      .filter(d=>d.properties[`${y}`])
      .map(d=>{
      for(let i=0;i<11;i++){d.properties[`${y+i}`]=+d.properties[`${y+i}`].replace(/ /g,'')*1000};
        return d
      });
      console.log(featuresWithPopulation);
      const featuresWithoutPopulation=countries.features
      .filter(d=>!d.properties[`${y}`]);
      
      return {
      features:countries.features,
      featuresWithPopulation
      };
    });